unit uTexture;

interface
type
  TGLTexture = record
    Height: Integer;
    Width: Integer;
    Data: array of Byte;
  end;


procedure LoadTextureFromBMP(const AFileName: String; var ATexture: TGLTexture);

implementation

uses Windows, Graphics;

procedure LoadTextureFromBMP(const AFileName: String; var ATexture: TGLTexture);
var
  i, j: Integer;
  bmp: TBitmap;
begin
  bmp := TBitmap.Create;
  try
    bmp.LoadFromFile(AFileName); //    

    ATexture.Height := bmp.Height;
    ATexture.Width  := bmp.Width;

    SetLength(ATexture.Data, bmp.Width* bmp.Height*3);
    //   
    For i:=0 to bmp.Height-1 do
      For j:=0 to bmp.Width-1 do begin
        ATexture.Data[(i*bmp.Width+j)*3+0]:=GetRValue(bmp.Canvas.Pixels[j, i]);
        ATexture.Data[(i*bmp.Width+j)*3+1]:=GetGValue(bmp.Canvas.Pixels[j, i]);
        ATexture.Data[(i*bmp.Width+j)*3+2]:=GetBValue(bmp.Canvas.Pixels[j, i]);
      end;
  finally
    bmp.Free;
  end;
end;


end.
